--ALTER TABLE ENERGY_DBA.TURNACT_LIST
-- DROP PRIMARY KEY CASCADE;
--DROP TABLE ENERGY_DBA.TURNACT_LIST CASCADE CONSTRAINTS;

CREATE TABLE ENERGY_DBA.TURNACT_LIST
(
  ID_SREZ      NUMBER(6),
  CREATE_DATE  DATE                             NOT NULL,
  CREATE_USER  NUMBER(6)                        NOT NULL,
  CHANGE_DATE  DATE,
  CHANGE_USER  NUMBER(6)
)
TABLESPACE USER_DATA
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

COMMENT ON TABLE ENERGY_DBA.TURNACT_LIST IS ' -  ';


CREATE UNIQUE INDEX ENERGY_DBA.TURNACT_LIST_PK ON ENERGY_DBA.TURNACT_LIST
(ID_SREZ)
LOGGING
TABLESPACE USER_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
NOPARALLEL;


--DROP PUBLIC SYNONYM TURNACT_LIST;

CREATE PUBLIC SYNONYM TURNACT_LIST FOR ENERGY_DBA.TURNACT_LIST;


ALTER TABLE ENERGY_DBA.TURNACT_LIST ADD (
  CONSTRAINT TURNACT_LIST_PK
 PRIMARY KEY
 (ID_SREZ)
    USING INDEX 
    TABLESPACE USER_DATA
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          64K
                NEXT             1M
                MINEXTENTS       1
                MAXEXTENTS       UNLIMITED
                PCTINCREASE      0
               ));

ALTER TABLE ENERGY_DBA.TURNACT_LIST ADD (
  CONSTRAINT TURNACT_LIST_SREZ 
 FOREIGN KEY (ID_SREZ) 
 REFERENCES ENERGY_DBA.SREZ (ID_SREZ)
    ON DELETE CASCADE);

GRANT DELETE, INSERT, SELECT, UPDATE ON ENERGY_DBA.TURNACT_LIST TO PUBLIC;


SET DEFINE OFF;

insert into TURNACT_LIST
(ID_SREZ, CREATE_DATE, CREATE_USER)
(select ID_SREZ, sysdate, ERPACK.S_USER_ID(USER) 
 from TURNACT_FIXEDCONDITIONS
 where ID_TURNACT_CONDITION = 2)
 
COMMIT;

