DECLARE
  id_class  NUMBER;
BEGIN

  id_class := ENERGY_DBA.ERPACK.S_CLASS_ID('TenXMLTurnAct1');
  if id_class = 0 then
    select ER_DBA.SEQ_S_BASE_CLASS.NextVal into id_class from dual;
  end if;
  delete from ER_DBA.S_BASE_CLASS where ID_BCLASS = id_class;

Insert into ER_DBA.S_BASE_CLASS
   (ID_BCLASS, NAME, PROPERTIES, QTEXT, RUS_NAME, 
    VERSION, VERSION_DATE, CREATE_DATE, CREATE_USER)
 Values
   (id_class, 'TenXMLTurnAct1', NULL, 'select 
  ID_SREZ,  
  CODE_FROM,
  CODE_TO,
  to_char(S_IDDATE, ''yyyymm'')||trim(to_char(DATE_NO, ''00''))||trim(to_char(HOUR_NO, ''00''))||''00'' BEG_DATE, 
  to_char(S_IDDATE, ''yyyymm'')||trim(to_char(DATE_NO, ''00''))||trim(to_char(HOUR_NO + 1, ''00''))||''00'' END_DATE,
  ZNAK power,  
  to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(S_IDDATE, ''mm.yyyy'')||'' ''||trim(to_char(HOUR_NO, ''00''))||'':00:00'', ''dd.mm.yyyy hh24:mi:ss'') BEG_DATE2,  
  to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(S_IDDATE, ''mm.yyyy'')||'' ''||trim(decode(HOUR_NO, 23, to_char(HOUR_NO, ''00'')||'':59:00'', to_char(HOUR_NO + 1, ''00'')||'':00:00'')), ''dd.mm.yyyy hh24:mi:ss'') END_DATE2 
from
  (select
    ID_SREZ,  
    CODE_FROM,
    CODE_TO,
    DATE_PERIOD,
    DATE_NO OLD_DATE_NO,
    HOUR_NO OLD_HOUR_NO,
    extract(DAY from S_IDDATE) DATE_NO,
    to_number(to_char(S_IDDATE, ''hh24'')) HOUR_NO,
    S_IDDATE,
    ZNAK
  from
    (select
      ID_SREZ,  
      max(CODE_FROM) CODE_FROM,
      max(CODE_TO) CODE_TO,
      DATE_PERIOD,
      DATE_NO,
      HOUR_NO,
     case
        when DATE_NO <= extract(DAY from last_day(DATE_PERIOD)) 
        then 
          to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(DATE_PERIOD, ''mm.yyyy'')||'' ''||trim(to_char(HOUR_NO, ''00''))||'':00:00'', ''dd.mm.yyyy hh24:mi:ss'') + (1*:SHIFT)/24  
      end S_IDDATE,
      sum(ZNAK) ZNAK
    from
      (select
        sf_d.ID_SREZ,
        sf_d.FOREM_CODE_FROM CODE_FROM,
        sf_d.FOREM_CODE_TO CODE_TO,
        sa.DATE_PERIOD,
        sad.DATE_NO,
        sad.HOUR_NO,
        sad.ZNAK
      from
        ENERGY_DBA.SALDO_ACTS sa,
        ENERGY_DBA.SALDO_ACTS_DETAIL sad,
        ENERGY_DBA.SREZ sf_d
      where
        sa.STATUS = 1
        and sad.ID_SAL_ACT = sa.ID_SAL_ACT
        and sa.ID_SREZ = :ID_HI
        and sf_d.ID_SREZ = sa.ID_SREZ)
    group by
      ID_SREZ,
      DATE_PERIOD,
      DATE_NO,
      HOUR_NO
order by
      ID_SREZ,
      DATE_PERIOD,
      DATE_NO,
      HOUR_NO
      ) s
  where 
    s.S_IDDATE between :BEG_DATE and (:END_DATE + 1 - 1/1440))', '51070  ', 
    2, TO_DATE('11/27/2007 00:00:00', 'MM/DD/YYYY HH24:MI:SS'), TO_DATE('11/27/2007 00:00:00', 'MM/DD/YYYY HH24:MI:SS'), 1);

  id_class := ENERGY_DBA.ERPACK.S_CLASS_ID('TenXMLTurnAct2');
  if id_class = 0 then
    select ER_DBA.SEQ_S_BASE_CLASS.NextVal into id_class from dual;
  end if;
  delete from ER_DBA.S_BASE_CLASS where ID_BCLASS = id_class;

Insert into ER_DBA.S_BASE_CLASS
   (ID_BCLASS, NAME, PROPERTIES, QTEXT, RUS_NAME, 
    VERSION, VERSION_DATE, CREATE_DATE, CREATE_USER)
 Values
   (id_class, 'TenXMLTurnAct2', NULL, '/*  */
select 
ID_SREZ,  
CODE_FROM,
CODE_TO,
to_char(DATE_PERIOD, ''yyyymm'')||trim(to_char(DATE_NO, ''00''))||trim(to_char(HOUR_NO, ''00''))||''00'' BEG_DATE, 
to_char(DATE_PERIOD, ''yyyymm'')||trim(to_char(DATE_NO, ''00''))||trim(to_char(HOUR_NO + 1, ''00''))||''00'' END_DATE,
ZNAK POWER,  
to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(DATE_PERIOD, ''mm.yyyy'')||'' ''||trim(to_char(HOUR_NO, ''00''))||'':00:00'', ''dd.mm.yyyy hh24:mi:ss'') BEG_DATE2,  
to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(DATE_PERIOD, ''mm.yyyy'')||'' ''||trim(decode(HOUR_NO, 23, to_char(HOUR_NO, ''00'')||'':59:00'', to_char(HOUR_NO + 1, ''00'')||'':00:00'')), ''dd.mm.yyyy hh24:mi:ss'') END_DATE2 
from
  (select
ID_SREZ,max(CODE_FROM) CODE_FROM,max(CODE_TO) CODE_TO,DATE_PERIOD,DATE_NO,HOUR_NO,sum(ZNAK) ZNAK
  from
    (select
ID_SREZ,CODE_FROM,CODE_TO,trunc(S_IDDATE, ''MONTH'') DATE_PERIOD,
extract(DAY from S_IDDATE) DATE_NO,
to_number(to_char(S_IDDATE, ''hh24'')) HOUR_NO,
ZNAK
    from
      (select
sa.DATE_PERIOD,
case
  when DATE_NO <= extract(DAY from last_day(DATE_PERIOD)) 
  then to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(DATE_PERIOD, ''mm.yyyy'')||'' ''||trim(to_char(HOUR_NO, ''00''))||'':00:00'', ''dd.mm.yyyy hh24:mi:ss'') + (1*:SHIFT)/24  
end S_IDDATE,
sf_d.ID_SREZ,
sf_d.FOREM_CODE_FROM CODE_FROM,
sf_d.FOREM_CODE_TO CODE_TO,
sad.DATE_NO,
sad.HOUR_NO,
sad.ZNAK
      from
ENERGY_DBA.SALDO_ACTS sa,
ENERGY_DBA.SALDO_ACTS_DETAIL sad,
ENERGY_DBA.SREZ_GROUP sg,
ENERGY_DBA.SREZ sf_d, 
ENERGY_DBA.TURNACT_SG tsg
      where
sa.STATUS = 1
and sad.ID_SAL_ACT = sa.ID_SAL_ACT
and sg.ID_LO = sa.ID_SREZ
and sf_d.ID_SREZ = sa.ID_SREZ
and sg.ID_HI = :ID_HI
and tsg.ID_HI = sg.ID_HI
and tsg.ID_LO = sg.ID_LO
and tsg.ADD_ACT = 1)
    where
S_IDDATE between :BEG_DATE and (:END_DATE + 1 - 1/1440))
  group by ID_SREZ,DATE_PERIOD,DATE_NO,HOUR_NO
  order by ID_SREZ,DATE_PERIOD,DATE_NO,HOUR_NO
  )
/*   */
union
select 
to_number(:ID_HI) ID_SREZ,  
CODE_FROM,
'''' CODE_TO,
to_char(DATE_PERIOD, ''yyyymm'')||trim(to_char(DATE_NO, ''00''))||trim(to_char(HOUR_NO, ''00''))||''00'' BEG_DATE, 
to_char(DATE_PERIOD, ''yyyymm'')||trim(to_char(DATE_NO, ''00''))||trim(to_char(HOUR_NO + 1, ''00''))||''00'' END_DATE,
ZNAK POWER,  
to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(DATE_PERIOD, ''mm.yyyy'')||'' ''||trim(to_char(HOUR_NO, ''00''))||'':00:00'', ''dd.mm.yyyy hh24:mi:ss'') BEG_DATE2,  
to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(DATE_PERIOD, ''mm.yyyy'')||'' ''||trim(decode(HOUR_NO, 23, to_char(HOUR_NO, ''00'')||'':59:00'', to_char(HOUR_NO + 1, ''00'')||'':00:00'')), ''dd.mm.yyyy hh24:mi:ss'') END_DATE2 
from
  (select
max(CODE_TO) CODE_FROM,max(CODE_TO) CODE_TO,DATE_PERIOD,DATE_NO,HOUR_NO,sum(ZNAK) ZNAK
  from
    (select
ID_SREZ,
CODE_FROM,
CODE_TO,
trunc(S_IDDATE, ''MONTH'') DATE_PERIOD,
extract(DAY from S_IDDATE) DATE_NO,
to_number(to_char(S_IDDATE, ''hh24'')) HOUR_NO,
ZNAK
    from
      (select
sf_d.ID_SREZ,
sf_d.FOREM_CODE_FROM CODE_FROM,
sf_d.FOREM_CODE_TO CODE_TO,
sa.DATE_PERIOD,
case
  when DATE_NO <= extract(DAY from last_day(DATE_PERIOD)) 
    then to_date(trim(to_char(DATE_NO, ''00''))||''.''||to_char(DATE_PERIOD, ''mm.yyyy'')||'' ''||trim(to_char(HOUR_NO, ''00''))||'':00:00'', ''dd.mm.yyyy hh24:mi:ss'') + (1*:SHIFT)/24  
end S_IDDATE,
sad.DATE_NO,
sad.HOUR_NO,
sad.ZNAK
      from
ENERGY_DBA.SALDO_ACTS sa,
ENERGY_DBA.SALDO_ACTS_DETAIL sad,
ENERGY_DBA.SREZ_GROUP sg,
ENERGY_DBA.SREZ sf_d, 
ENERGY_DBA.TURNACT_SG tsg
      where
sa.STATUS = 1
and sad.ID_SAL_ACT = sa.ID_SAL_ACT
and sg.ID_LO = sa.ID_SREZ
and sf_d.ID_SREZ = sa.ID_SREZ
and sg.ID_HI = :ID_HI
and tsg.ID_HI = sg.ID_HI
and tsg.ID_LO = sg.ID_LO
and tsg.ADD_POTR = 1) sad
    where
S_IDDATE between :BEG_DATE and (:END_DATE + 1 - 1/1440))
  group by DATE_PERIOD,DATE_NO,HOUR_NO
  order by DATE_PERIOD,DATE_NO,HOUR_NO
  )', '51070  ( 2006)', 
    2, TO_DATE('11/27/2007 00:00:00', 'MM/DD/YYYY HH24:MI:SS'), TO_DATE('11/27/2007 00:00:00', 'MM/DD/YYYY HH24:MI:SS'), 1);


  id_class := ENERGY_DBA.ERPACK.S_CLASS_ID('TenTurnActList');
  if id_class = 0 then
    select ER_DBA.SEQ_S_BASE_CLASS.NextVal into id_class from dual;
  end if;
  delete from ER_DBA.S_BASE_CLASS where ID_BCLASS = id_class;

Insert into ER_DBA.S_BASE_CLASS
   (ID_BCLASS, NAME, PROPERTIES, QTEXT, RUS_NAME, 
    VERSION, VERSION_DATE, CREATE_DATE, CREATE_USER)
 Values
   (id_class, 'TenTurnActList', XMLTYPE('<Properties>
  <ClassCaption>- </ClassCaption>
  <TablesName>TURNACT_LIST</TablesName>
  <PrimaryKeyList>ID_SREZ</PrimaryKeyList>
  <ColumnList>ID_SREZ,CREATE_DATE,CREATE_USER,CHANGE_DATE,CHANGE_USER</ColumnList>
  <InvisibleColumns>ID_SREZ,CREATE_DATE,CREATE_USER,CHANGE_DATE,CHANGE_USER</InvisibleColumns>
  <PrivList>ADMINS,REAL_ADMIN</PrivList>
  <ViewProperties>
    <Field PropType="TenSGroup" Name="" DisplayWidth="25" KeyFieldName="ID_SREZ" LookupKeyFieldName="ID_SREZ" LookupResultFieldName="IDNAME">IDNAME</Field>
  </ViewProperties>
</Properties>'), 'select 
  l.ID_SREZ
  , s.IDNAME
  , l.CREATE_DATE
  , l.CREATE_USER
  , l.CHANGE_DATE
  , l.CHANGE_USER
from
  TURNACT_LIST l
  , SREZ s
--  , SREZ_PERM sp 
where
  s.ID_SREZ = l.ID_SREZ
--  and sp.ID_SREZ = l.ID_SREZ
--  and sp.USERNAME = USER
order by
  s.IDNAME
', '  - ', 
    1, TO_DATE('01/17/2011 00:00:00', 'MM/DD/YYYY HH24:MI:SS'), TO_DATE('01/17/2011 00:00:00', 'MM/DD/YYYY HH24:MI:SS'), 1);
    
COMMIT;
END;
/

